# ADS2 - Implementierung in Rust #

Im Ordner [./src/*](src/) findet Module mit Datenstrukturen und Algorithmen.

Im Ordner [./test/*](test/) findet man _unit tests_,
die die verschiedenen Datenstrukturen und Algorithmen mit Testfälle belasten.
Man kann auch direkt im Code von [./src/main.rs](src/main.rs) aus
die Methoden mit Daten ausprobieren.

## Voraussetzungen ##

1. Der Rust-Compiler wird benötigt und
  hierfür ist der **cargo** Package-Manager zu empfehlen.
  Siehe <https://www.rust-lang.org/tools/install> für die offizielle Anleitung.
2. Es ist auch empfehlenswert, **make** zu installieren.
  - Linux/OSX: siehe <https://formulae.brew.sh/formula/make>.
  - Windows: siehe <https://community.chocolatey.org/packages/make>.

## Build -> Test -> Run ##

Navigiere im IDE zum [rust](/)-Ordner in deinem IDE.
Öffne eine bash-Konsole und führe folgende Befehle aus:

Wer **make** hat:
```bash
# zum Kompilieren (nur nach Änderungen nötig):
make build;
# zur Ausführung der unit tests:
make tests;
# zur Ausführung des Programms
make run;
# zur Bereinigung aller Artefakte
make clean;
```
Wer _kein_ make hat:
```bash
# zum Kompilieren (nur nach Änderungen nötig):
cargo build --release;
# zur Ausführung der unit tests:
cargo test;
# zur Ausführung des Programms
dist/ads2 # oder den gebauten Artefakt mit Maus doppelklicken
```
Der `build` Schritt baut einen binären Artefekt
und kopiert dies nach dem [./dist/*](dist/) Ordner.
